import type { RegistryScriptInput } from '#nuxt-scripts/types';
export declare const RybbitAnalyticsOptions: import("valibot").ObjectSchema<{
    readonly siteId: import("valibot").StringSchema<undefined>;
    readonly trackSpa: import("valibot").OptionalSchema<import("valibot").BooleanSchema<undefined>, undefined>;
    readonly trackQuery: import("valibot").OptionalSchema<import("valibot").BooleanSchema<undefined>, undefined>;
    readonly skipPatterns: import("valibot").OptionalSchema<import("valibot").ArraySchema<import("valibot").StringSchema<undefined>, undefined>, undefined>;
    readonly maskPatterns: import("valibot").OptionalSchema<import("valibot").ArraySchema<import("valibot").StringSchema<undefined>, undefined>, undefined>;
    readonly debounce: import("valibot").OptionalSchema<import("valibot").NumberSchema<undefined>, undefined>;
}, undefined>;
export type RybbitAnalyticsInput = RegistryScriptInput<typeof RybbitAnalyticsOptions, false>;
export interface RybbitAnalyticsApi {
    pageview: () => void;
    event: (eventName: string, properties?: Record<string, any>) => void;
}
declare global {
    interface Window {
        rybbit: RybbitAnalyticsApi;
    }
}
export declare function useScriptRybbitAnalytics<T extends RybbitAnalyticsApi>(_options?: RybbitAnalyticsInput): import("#nuxt-scripts/types").UseScriptContext<T>;
